#include <bits/stdc++.h>
#include<vector>
#define ll long long
#define f first
#define s second
using namespace std;
double bin_power(double a, long long n){
    if (n == 0)
        return 1;
    if (n % 2 == 0){
        double z = bin_power(a, n / 2);
        return z * z;
    }
    else
        return a * bin_power(a, n - 1);
}
ll d[500000], w[500000];
double dp[500000];
pair <long long, long long> dw[500000];
int main()
{
    int n, m;
    cin >> n >> m;
    double r;
    cin >> r;
    for (int i = 1; i <= n; i++){
        cin >> dw[i].f >> dw[i].s;
    }
    sort(dw + 1, dw + n + 1);  
    for (int i = 1; i <= n; i++)
        d[i] = dw[i].f;
        
    for (int i = 1; i <= n; i++){
        dp[i] = dp[i - 1] * bin_power(1.0 - r, dw[i].f - dw[i - 1].f) + dw[i].s * r;
        //cout << dp[i] << endl;
        
    }
   // return 0;
    cout  << fixed << setprecision(7);
    for (int i = 1; i <= m; i++){
        int q;
        cin >> q;
        int pos = int(upper_bound(d, d + n + 1, q) - d) - 1;
        double ans = dp[pos] * bin_power(1.0 - r, q - d[pos]);
        
        cout << ans << ' ';
    }    
    
}